% runge_kutta
clear all
close all
del_t = 0.1;
t = 0.0:del_t:20.0;

a = 0.5; b = 1-a;
alpha = 0.5/b;  %p_1 na deducao
beta = 0.5/b;  %q_11 na deducao
n = length(t);
y = zeros(size(t));
y(1) = 1;
for ii = 1:n-1
k_1 = del_t*func(t(ii),y(ii));
k_2 = del_t*func(t(ii)+alpha*del_t,y(ii)+beta*k_1);
y(ii+1) = y(ii) + a * k_1 + b * k_2;
end
exact = exp(t-t.^2/2);

erro=exact-y;
figure(1)
subplot(2,1,1)
plot(t,y,'--',t,exact)
legend ('numerico', 'analitico')
subplot(2,1,2)
plot(t, erro)
legend ('erro=analitico-numerico')

% Mtodo Euler progressivo
ye = zeros(size(t));
ye(1) = 1;
for i = 1:(length(t)-1)
ye(i+1) = ye(i) + del_t * ye(i)*(1-t(i));
end

% calculo do erro
erroe=exact-ye;

figure(2)
subplot(2,1,1)
plot(t,y,'--',t,exact, t,ye)
hold on
a = 0; b = 1-a;
alpha = 0.5/b;  %a_1 na deducao
beta = 0.5/b;  %q_11 na deducao
n = length(t);
y2 = zeros(size(t));
y2(1) = 1;
for iii = 1:n-1
k_1 = del_t*func(t(iii),y2(iii));
k_2 = del_t*func(t(iii)+alpha*del_t,y2(iii)+beta*k_1);
y2(iii+1) = y2(iii) + a * k_1 + b * k_2;
end
plot(t,y2,'o')
legend ('RK com a_2=0,5', 'exato','euler','RK com a_2=0')
hold off
subplot(2,1,2)
erro2=exact-y2;
plot(t, erro,'--', t, erroe, t,erro2,'x')
legend('erro RK com a_2=0,5', 'erro euler','erro RK com a_2=0,5')
erro_RK=max(abs(erro))
erroe_Euler=max(abs(erroe))

y0 = 1; tspan = [0 5];
figure(3)
ode45('func',tspan,y0);