close all
clear all
% Mtodo Euler progressivo
dt = 0.1;
t = [0.0:dt:5.0];
y = zeros(size(t));
y(1) = 1;
for i = 1:(length(t)-1)
y(i+1) = y(i) + dt * (1-t(i))*y(i); % metodo euler para dy/dt = (1-t)y
end
exact = exp(t-t.^2/2);
figure(1)
plot(t,y,'--',t,exact)
legend ('numerico', 'analitico')

errorel=(exact-y)./exact*100;
erro=exact-y;
figure(2)
subplot(3,1,1)
plot(t,y,'--',t,exact)
legend ('numerico', 'analitico')
subplot(3,1,2)
plot(t, erro)
legend ('erro absoluto = analitico-numerico')    
subplot(3,1,3)
plot(t, errorel)
legend ('erro relativo = (analitico-numerico)/analitico') 
  
% euler regressivo
dt2 = 0.1;
t2 = [0.0:dt2:5.0];
y2 = zeros(size(t2));
y2(1) = 1;
for i = 1:(length(t2)-1)
y2(i+1) = y2(i)/(1-dt2*(1-t2(i+1)));
end
exact2 = exp(t2-t2.^2/2);

erro2=exact2-y2;
figure(3)
subplot(2,1,1)
plot(t,y,'--',t,exact, t2, y2, '.')
legend ('numerico progressivo', 'analitico', 'numerico regressivo')
subplot(2,1,2)
plot(t, erro, t2, erro2)
legend ('erro=analitico-progressivo','erro2=analitico-regressivo')
erromax=max(erro)
erromaxres=max(erro2)

figure(4)
funcao=@(t,y) (1-t)*y
[t4,y4] = ode23(funcao,[0 5],1)
plot(t4,y4,'o',t,exact, t2, y2, '.')
legend ('numerico ode', 'analitico', 'numerico regressivo')
