close all
clear all

%% definir constantes e condicoes iniciais
g=9.81;
m=input('mass (kg):');
cd=12.5; %coeficiente de arastre
ti=0; % tempo inicial
tf=20; % tempo final
vi=0; % velocidade inicial
dt=0.1; % passo temporal

%% definir variaveis
t = ti;
v = vi;
h = dt;
plot(t,v,'o')
xlabel time
ylabel velocity
xlim([ti tf])
hold on

%% calculo numerico
while (1)  % ate que condicao  verdade (interromper com break)
    if t+dt > tf
        h =tf-t;
    end
    dvdt = g - (cd/m)*v; % equacao diferencial  dv/dt = g - (cd/m)*v
    v = v + dvdt * h; % metodo euler (v(t_i+1) = v(t_i) + v'*(t_i+1 - t_i)
    t = t + h; % avancar um passo em tempo
    plot(t,v,'o')
    hold on
    if t >= tf, break,end % verficiar se ja terminou
end
disp('velocity (numerical method) (m/s):')
disp(v)
va=g*m/cd*(1-exp(-cd/m*tf)); % solucao analitica de dv/dt = g - (c/m)*v (paraquedista)
disp('velocity (analytical) (m/s):')
disp(va)
erro= va-v % calcular erro
erro_relativo_porcento = (va-v)/va*100

%% visualizacao solucao analitica
tempo=ti:dt:tf;
plot (tempo,g*m/cd*(1-exp(-cd/m*tempo)), 'r')

