close all
clear all
% Mtodo Euler
dt = 0.1;
t = [0.0:dt:1.0];
y = zeros(size(t));
y(1) = 1;
for i = 1:(length(t)-1)
y(i+1) = y(i) + dt * y(i)*(-20*y(i)+20*t(i)^2+2*t(i));  %dy/dt = y*(-20y+20t^2+2t)
end
exact = exp(-20*t)+t.^2;

% calculo do erro
erro=exact-y;
figure(1)
subplot(2,1,1)
plot(t,y,'--',t,exact)
axis([0 1 -2 2])
legend ('numerico', 'analitico')
subplot(2,1,2)
plot(t, erro)
axis([0 1 -2 2])
legend ('erro=analitico-numerico')   
    
% resolucao maior
dt2 = 0.001;
t2 = [0.0:dt2:1.0];
y2 = zeros(size(t2));
y2(1) = 1;
for i = 1:(length(t2)-1)
y2(i+1)= y2(i) + dt2 * y2(i)*(-20*y2(i)+20*t2(i)^2+2*t2(i));
end
exact2 = exp(-20*t2)+t2.^2;

% calculo do erro
erro2=exact2-y2;
figure(2)
subplot(2,1,1)
plot(t2,y2,'--',t2,exact2)
legend ('euler mais resolvido', 'analitico')
subplot(2,1,2)
plot(t2, erro2)
axis([0 1 -2 2])
legend ('erro2=analitico-eulermaisresolvido')

figure(3)
subplot(2,1,1)
plot(t,y,'--',t2,exact2, t2, y2)
axis([0 1 -2 2])
legend ('euler', 'analitico', 'euler2')
subplot(2,1,2)
plot(t, erro, t2, erro2)
axis([0 1 -2 2])
legend ('erro=analitico-euler','erro2=analitico-euler2')

% backward difference
y3 = zeros(size(t));
y3(1) = 1;
for i = 1:(length(t)-1)
y3(i+1) = (y3(i) + dt*(20*(t(i)+dt)^2+2*t(i)+dt))/(1+20*dt);
end
% 
erro3=exact-y3;

figure(4)
subplot(2,1,1)
plot(t,y3,'--',t,exact, t2, y2)
legend ('euler-regressivo', 'analitico', 'euler mais resolvido')
subplot(2,1,2)
plot(t2, erro2, t, erro3)
legend ('erro2=analitico-euler mais resolvido', 'erro3=analitico-backward-difference')


max(erro3)